<template>
  <div class="game">
    <div class="game__header">
      <h1>Good luck, {{ username }}</h1>
      <div class="game__score">
        <span>Your score: {{ score }}</span>
      </div>
    </div>
    <div class="game__content">
      <div class="game__instructions--top">
        <span>Pick up the right cards</span>
        <span>The faster the better!</span>
      </div>
      <div class="messy-cards">
        <div
          class="card"
          v-for="(card, i) in shuffledCards"
          :key="`${gameNumber}-shuffledCard-${i}`"
        >
          <div
            class="card__img"
            :id="`card${card.id}`"
            :data-card="JSON.stringify(card)"
            draggable
            @dragstart="startDragCard($event, card)"
            :style="{ '--image-url': 'url(' + card.src + ')' }"
          />
        </div>
      </div>
      <span class="game__instructions--mid">
        ... and drop them here to make the logo great again
      </span>
      <div class="slots">
        <div
          class="slot"
          v-for="(slot, slotIndex) in slots"
          :key="`${gameNumber}-slot-${slotIndex}`"
          :data-idx="slotIndex"
          @drop="dropCard($event, slotIndex)"
          @dragover.prevent
        />
      </div>
    </div>
    <result-dialog
      :score="score"
      :countdown="countdown"
      :show-results="victory"
    />
  </div>
</template>

<script>
import ResultDialog from "@/components/ResultDialog.vue";
import { mapState } from "vuex";

export default {
  components: {
    ResultDialog
  },
  data() {
    return {
      orderedCards: [
        { id: 1, src: "assets/zoovu-z.svg", letter: "z" },
        { id: 2, src: "assets/zoovu-o.svg", letter: "o" },
        { id: 3, src: "assets/zoovu-o.svg", letter: "o" },
        { id: 4, src: "assets/zoovu-v.svg", letter: "v" },
        { id: 5, src: "assets/zoovu-u.svg", letter: "u" }
      ],
      shuffledCards: [],
      slots: [],
      cardBox: "",
      refineChoice: false,
      score: 0,
      countdown: 10,
      counter: null,
      gameNumber: 0,
      restartCounter: null,
      startGame: false,
      wrongAnswer: false,
      victory: false
    };
  },
  computed: {
    ...mapState({
      username: state => state.username
    })
  },
  methods: {
    shuffleCards() {
      this.shuffleCards = [];
      this.orderedCards.forEach(card => {
        this.shuffledCards.push(Object.assign({}, card));
      });
      this.shuffledCards.sort(() => {
        return Math.random() - 0.5;
      });

      this.slots = [];
      this.orderedCards.forEach(card => {
        this.slots.push({
          answer: card.letter,
          choice: ""
        });
      });
    },
    startDragCard(event, card) {
      if (!this.startGame) {
        this.startGame = true;
      }
      this.cardBox = event.currentTarget.parentElement;
      this.refineChoice = this.cardBox.classList[0] === "slot";
      if (this.refineChoice) {
        card.position = parseInt(this.cardBox.dataset.idx);
      }
      event.dataTransfer.setData("cardData", JSON.stringify(card));
      event.dataTransfer.effectAllowed = "move";
    },
    dropCard(event, slotIndex) {
      event.preventDefault();
      let droppedCardData = event.dataTransfer.getData("cardData");
      let droppedCard = droppedCardData ? JSON.parse(droppedCardData) : null;
      let filledSlot = false;

      if (droppedCard) {
        filledSlot = event.currentTarget.children.length > 0;
        if (this.refineChoice && filledSlot) {
          this.updateSlotChoices(droppedCard.position, slotIndex);
          this.cardBox.appendChild(event.target);
          event.currentTarget.appendChild(this.cardBox.children[0]);
        } else {
          if (!filledSlot) {
            this.updateSlotChoices(
              droppedCard.position,
              slotIndex,
              droppedCard.letter
            );
            event.currentTarget.appendChild(
              document.getElementById(`card${droppedCard.id}`)
            );
          }
        }
        this.refineChoice = false;
        this.validateVictory();
      }
    },
    updateSlotChoices(from, to, newChoice) {
      if (!newChoice) {
        var auxChoice = this.slots[from].choice;
        this.slots[from].choice = this.slots[to].choice;
        this.slots[to].choice = auxChoice;
      } else {
        if (from) {
          this.slots[from].choice = "";
        }
        this.slots[to].choice = newChoice;
      }

      if (this.slots[to].choice !== this.slots[to].answer) {
        this.score += 10;
      }
    },
    validateVictory() {
      const wrongChoices = this.slots.filter(
        card => card.choice !== card.answer
      );
      if (wrongChoices.length === 0) {
        this.startGame = false;
        this.victory = true;
        this.restartCounter = setInterval(() => {
          this.countdown--;
          if (this.countdown === 0) {
            this.countdown = 10;
            this.gameNumber++;
            this.victory = false;
            this.score = 0;
            clearInterval(this.restartCounter);
            this.shuffleCards();
          }
        }, 1000);
      }
    }
  },
  watch: {
    startGame(value) {
      if (!value) {
        clearInterval(this.counter);
      } else {
        this.counter = setInterval(() => {
          this.score++;
        }, 1000);
      }
    }
  },
  created() {
    this.shuffleCards();
  }
};
</script>

<style lang="scss" scoped>
.game {
  margin: auto;
  display: flex;
  flex-direction: column;
  padding: 40px 80px;
  height: calc(100% - 80px);
  max-width: 1200px;
}
.game__content {
  flex: 1;
}
.game__header {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  margin: 40px 0;
}
.game__header h1,
.game__header span {
  font-size: 1.2rem;
}
.game__header h1 {
  font-weight: bold;
}
.game__header span {
  color: #541c7c;
}
.game__instructions--top {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  font-size: 0.75rem;
  margin-bottom: 60px;
}
.game__instructions--mid {
  display: inline-block;
  width: 100%;
  text-align: left;
  font-size: 0.75rem;
  margin: 100px 0 50px;
}
.game__instructions--top span,
.game__instructions--mid {
  color: #b1b1b1;
}
.messy-cards,
.slots {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
}
.card,
.slot,
.card__img {
  height: 180px;
  width: 180px;
  border-radius: 10px;
}
.card,
.slot {
  position: relative;
}
.card__img {
  background: var(--image-url) no-repeat center center;
  background-color: #fff;
  -webkit-box-shadow: 3px 3px 10px 5px rgba(160, 160, 160, 0.25);
  box-shadow: 3px 3px 10px 5px rgba(160, 160, 160, 0.25);
}
.slot {
  box-sizing: border-box;
  border: 2px dashed #52d19a;
}
.slot > .card__img {
  position: absolute;
  top: -2px;
  left: -2px;
}
</style>
